
cd u:\files\papers\lindic\fr
clear
log using table7.log, replace

set more 1
set matsize 300
set memory 3000


use datay96

* This is updated for 1996 for defrat, resm2, ressh, reservem from WDI 1998 CD Rom

g col1=1 if  (comrat~=.) & (conrat~=.) & (varrat~=.) & (shorttot~=.) & (fdistock~=.) & (pubrat~=.) & (multirat~=.) & (debty~=.) & (reservem~=.) & (canm~=.) & (overvalo~=.) & (defrat~=.) & (dlcred~=.) & (dly~=.) & (istar~=.) & (dloecdy~=.)


g byte ss1n=0
replace ss1n=1 if (country=="ARG")| (country=="BOL") | (country=="BRA") | (country=="CHL") | (country=="COL") | (country=="HUN") | (country=="IND")
replace ss1n=1 if (country=="IDN") | (country=="KOR") | (country=="MYS") | (country=="MEX") | (country=="PER") | (country=="PAK") | (country=="PHL")
replace ss1n=1 if (country=="PRT") | (country=="ZAF") | (country=="LKA") | (country=="THA") | (country=="TUR") | (country=="URY") | (country=="VEN")
replace ss1n=1 if (country=="DZA") | (country=="BWA") | (country=="CRI") | (country=="CIV") | (country=="DOM") | (country=="ECU") | (country=="EGY")
replace ss1n=1 if (country=="SLV") | (country=="GTM") | (country=="IRN") | (country=="JAM") | (country=="MUS")| (country=="MAR") | (country=="OMN")
replace ss1n=1 if (country=="PAN") | (country=="PRY") |(country=="ROM") | (country=="SYR") | (country=="TTO") | (country=="TUN") | (country=="ZWE")

g sample2=1 if (eventld~=.)&(comrat~=.)&(conrat~=.)&(varrat~=.)&(shorttot~=.)& (fdistock~=.)& (pubrat~=.)& (multirat~=.) & (debty~=.) & (reservem~=.) & (canm~=.) & (overvalo~=.) &(defrat~=.) & (dlcred~=.) & (dly~=.) & (istar~=.) & (dloecdy~=.) & (ss1==1)
count if sample2==1

g sample2n=1 if (eventld~=.)&(comrat~=.)&(conrat~=.)&(varrat~=.)&(shorttot~=.)& (fdistock~=.)& (pubrat~=.)& (multirat~=.) & (debty~=.) & (reservem~=.) & (canm~=.) & (overvalo~=.) &(defrat~=.) & (dlcred~=.) & (dly~=.) & (istar~=.) & (dloecdy~=.) & (ss1n==1)
count if sample2 != sample2n

drop if date==1997

*Column 1
dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty reservem canm overvalo defrat dlcred dly istar dloecdy if col1==1
* edit    eventld comrat conrat varrat shorttot fdistock pubrat multirat debty reservem canm overvalo defrat dlcred dly istar dloecdy if date==1996

predict prob1
g pred1 = prob1
replace pred1=1 if pred1>.5 & pred1~=.
replace pred1=0 if pred1<.5
tab pred1 eventld


*Column 1i:FR spec, defrati

dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty reservem canm overvalo defrati dlcred dly istar dloecdy if col1==1

predict prob1i
g pred1i = prob1i
replace pred1i=1 if pred1i>.5 & pred1i~=.
replace pred1i=0 if pred1i<.5
tab pred1i eventld


*************************************************************************************
**** THIS IS FINAL TABLE 7 COLUMN 1 ******************
*********************************************************************
* Column 1h: FR spec, defrath
dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty reservem canm overvalo defrath dlcred dly istar dloecdy if col1==1

predict prob1h
g pred1h = prob1h
replace pred1h=1 if pred1h>.5 & pred1h~=.
replace pred1h=0 if pred1h<.5
tab pred1h eventld

** cutoff of 0.25
g pred1h4 = prob1h
replace pred1h4=1 if pred1h4>.25 & pred1h4~=.
replace pred1h4=0 if pred1h4<.25
tab pred1h4 eventld



 *Column 2
dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty reservem canm overvalo dlcred dly istar dloecdy if col1==1

predict prob2
g pred2 = prob2
replace pred2=1 if pred2>.5 & pred2~=.
replace pred2=0 if pred2<.5
tab pred2 eventld




* edit country prob1 pred1 if date==1996

*Column 3:FR spec, small sample, defrat

dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty reservem canm overvalo defrat dlcred dly istar dloecdy if ss1==1

predict prob3
g pred3 = prob3
replace pred3=1 if pred3>.5 & pred3~=.
replace pred3=0 if pred3<.5
tab pred3 eventld if ss1==1

*Column 3i:FR spec, small sample, defrati

dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty reservem canm overvalo defrati dlcred dly istar dloecdy if ss1==1

predict prob3i
g pred3i = prob3i
replace pred3i=1 if pred3i>.5 & pred3i~=.
replace pred3i=0 if pred3i<.5
tab pred3i eventld if ss1==1



*************************************************************************************
**** THIS IS FINAL TABLE 7 COLUMN 2 ******************
*********************************************************************
*Column 3h:FR spec, small sample, defrath

dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty reservem canm overvalo defrath dlcred dly istar dloecdy if ss1==1

predict prob3h
g pred3h = prob3h
replace pred3h=1 if pred3h>.5 & pred3h~=.
replace pred3h=0 if pred3h<.5
tab pred3h eventld if ss1==1

** cutoff of 0.25
g pred3h4 = prob3h
replace pred3h4=1 if pred3h4>.25 & pred3h4~=.
replace pred3h4=0 if pred3h4<.25
tab pred3h4 eventld if ss1==1

*Column 4:FR spec, small sample no defrat

dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty reservem canm overvalo dlcred dly istar dloecdy if ss1==1

predict prob4
g pred4 = prob4
replace pred4=1 if pred4>.5 & pred4~=.
replace pred4=0 if pred4<.5
tab pred4 eventld if ss1==1


* Column 5: our spec, small sample

dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty ressh resm2 canm overvalo defrat dlcred dly istar dloecdy open if ss1n==1
predict prob5
g pred5 = prob5
replace pred5=1 if pred5>.5 & pred5~=.
replace pred5=0 if pred5<.5
tab pred5 eventld if ss1==1

*Column 5i:Our spec, small sample, defrati

dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty ressh resm2 canm overvalo defrati dlcred dly istar dloecdy open if ss1n==1
predict prob5i
g pred5i = prob5i
replace pred5i=1 if pred5i>.5 & pred5i~=.
replace pred5i=0 if pred5i<.5
tab pred5i eventld if ss1==1

*************************************************************************************
**** THIS IS FINAL TABLE 7 COLUMN 3 ******************
*********************************************************************
* Column3: not used to forecast but show ressh and reservem
dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty reservem ressh resm2 canm overvalo defrath dlcred dly istar dloecdy open if ss1n==1



*************************************************************************************
**** THIS IS FINAL TABLE 7 COLUMN 4 ******************
*********************************************************************
*Column 5h:Our spec, small sample, defrath
dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty resm2 canm overvalo defrath dlcred dly istar dloecdy open if ss1n==1
predict prob5h
g pred5h = prob5h
replace pred5h=1 if pred5h>.5 & pred5h~=.
replace pred5h=0 if pred5h<.5
tab pred5h eventld if ss1==1

** cutoff of 0.25
g pred5h4 = prob5h
replace pred5h4=1 if pred5h4>.25 & pred5h4~=.
replace pred5h4=0 if pred5h4<.25
tab pred5h4 eventld if ss1==1


*Column 6:our spec, small sample, no defrat

dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty ressh resm2 canm overvalo dlcred dly istar dloecdy open if ss1n==1

predict prob6
g pred6 = prob6
replace pred6=1 if pred6>.5 & pred6~=.
replace pred6=0 if pred6<.5
tab pred6 eventld if ss1==1


edit country name prob1 prob2  prob3  prob3i prob3h prob4 prob5 prob5i prob5h  ss1n if date==1996 & ((prob1>0 & prob1 ~= .) | (prob2 >0 & prob2 ~= .) | (prob3 > 0 & prob3 ~= .) | (prob4>0 & prob4 ~= .) | (prob5>0 & prob5 ~= .))
* edit country name prob1 prob2 prob3 prob4 prob5 ss1n eventld comrat conrat varrat shorttot fdistock pubrat multirat debty ressh resm2 canm overvalo dlcred dly istar dloecdy open if date==1996 & ((prob1>0 & prob1 ~= .) | (prob2 >0 & prob2 ~= .) | (prob3 > 0 & prob3 ~= .) | (prob4>0 & prob4 ~= .) | (prob5>0 & prob5 ~= .) | (country == "BRA" | country=="IDN"))

keep if date==1996
keep if predsam==1
keep date country name prob1 prob1i prob1h prob2 prob3 prob3i prob3h prob4 prob5 prob5i prob5h prob6 ss1n
compress
sort country date
save fcasts.dta, replace

log close
